diff --git a/layout/reftests/w3c-css/import-tests.py b/layout/reftests/w3c-css/import-tests.py
index 1a631e2bec..bb1db3a8f0 100755
--- a/layout/reftests/w3c-css/import-tests.py
+++ b/layout/reftests/w3c-css/import-tests.py
@@ -80,7 +80,7 @@ def log_output_of(subprocess):
     global gLog
     subprocess.wait()
     if (subprocess.returncode != 0):
-        raise StandardError("error while running subprocess")
+        raise Exception("error while running subprocess")
     gLog.write(subprocess.stdout.readline().rstrip())
 
 def write_log_header():
@@ -124,7 +124,7 @@ def populate_test_files():
 def copy_file(test, srcfile, destname, isSupportFile=False):
     global gDestPath, gLog, gSrcPath
     if not srcfile.startswith(gSrcPath):
-        raise StandardError("Filename " + srcfile + " does not start with " + gSrcPath)
+        raise Exception("Filename " + srcfile + " does not start with " + gSrcPath)
     logname = srcfile[len(gSrcPath):]
     gLog.write("Importing " + to_unix_path_sep(logname) +
                " to " + to_unix_path_sep(destname) + "\n")
@@ -133,7 +133,7 @@ def copy_file(test, srcfile, destname, isSupportFile=False):
     if not os.path.exists(destdir):
         os.makedirs(destdir)
     if os.path.exists(destfile):
-        raise StandardError("file " + destfile + " already exists")
+        raise Exception("file " + destfile + " already exists")
     copy_and_prefix(test, srcfile, destfile, gPrefixedProperties, isSupportFile)
 
 def copy_support_files(test, dirname):
@@ -216,7 +216,7 @@ def add_test_items(srcname):
         else:
             gLog.write("Warning: href attribute found empty in " + srcname + "\n")
     if len(refs) > 1:
-        raise StandardError("Need to add code to specify which reference we want to match.")
+        raise Exception("Need to add code to specify which reference we want to match.")
     for ref in refs:
         tests.append(["==", map_file(srcname), map_file(ref)])
     for notref in notrefs:
@@ -287,7 +287,7 @@ def setup_paths():
     gSrcPath = gArgs[0]
     if not os.path.isdir(gSrcPath) or \
     not os.path.isdir(os.path.join(gSrcPath, ".hg")):
-        raise StandardError("source path does not appear to be a mercurial clone")
+        raise Exception("source path does not appear to be a mercurial clone")
 
     gDestPath = os.path.join(os.path.dirname(os.path.realpath(__file__)), "received")
     newSubtrees = []
@@ -339,7 +339,7 @@ def main():
                 listfile.write("\ndefault-preferences {0}\n\n".format(defaultPreferences))
             lastDefaultPreferences = defaultPreferences
         key = 1
-        while not test[key] in gTestFlags.keys() and key < len(test):
+        while not test[key] in list(gTestFlags.keys()) and key < len(test):
             key = key + 1
         testType = test[key - 1]
         testFlags = gTestFlags[test[key]]
diff --git a/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-line-height-tests.py b/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-line-height-tests.py
index 7aa975aaa6..ccc8d2923a 100644
--- a/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-line-height-tests.py
+++ b/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-line-height-tests.py
@@ -10,6 +10,7 @@ reftest.list to the stdout.
 
 from __future__ import unicode_literals
 
+from __future__ import print_function
 TEST_FILE = 'text-emphasis-line-height-{:03}{}.html'
 TEST_TEMPLATE = '''<!DOCTYPE html>
 <meta charset="utf-8">
@@ -62,7 +63,7 @@ def write_file(filename, content):
     with open(filename, 'wb') as f:
         f.write(content.encode('UTF-8'))
 
-print("# START tests from {}".format(__file__))
+print(("# START tests from {}".format(__file__)))
 idx = 0
 for (pos, emphasis_pos, ruby_pos, wms, dir) in POSITIONS:
     idx += 1
@@ -78,5 +79,5 @@ for (pos, emphasis_pos, ruby_pos, wms, dir) in POSITIONS:
                 pos=pos, wm=wm, tag=tag, index=idx, dir=dir,
                 start=start.format(style1=style1, style2=STYLE2), end=end)
             write_file(test_file, content)
-            print("== {} {}".format(test_file, ref_file))
-print("# END tests from {}".format(__file__))
+            print(("== {} {}".format(test_file, ref_file)))
+print(("# END tests from {}".format(__file__)))
diff --git a/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-position-property-tests.py b/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-position-property-tests.py
index 94701b57f2..f843919ba8 100644
--- a/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-position-property-tests.py
+++ b/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-position-property-tests.py
@@ -11,6 +11,7 @@ tests it generated in the format of Mozilla reftest.list to the stdout.
 
 from __future__ import unicode_literals
 
+from __future__ import print_function
 import itertools
 
 TEST_FILE = 'text-emphasis-position-property-{:03}{}.html'
@@ -72,8 +73,8 @@ for wm in WRITING_MODES:
         if wm != "horizontal-tb":
             write_test_files(wm, "sideways", pos1, pos2)
 
-print("# START tests from {}".format(__file__))
+print(("# START tests from {}".format(__file__)))
 reftest_items.sort()
 for item in reftest_items:
     print(item)
-print("# END tests from {}".format(__file__))
+print(("# END tests from {}".format(__file__)))
diff --git a/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-ruby-tests.py b/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-ruby-tests.py
index bb2f9706ad..4db2584a50 100644
--- a/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-ruby-tests.py
+++ b/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-ruby-tests.py
@@ -9,6 +9,7 @@ tests it generated in the format of Mozilla reftest.list to the stdout.
 
 from __future__ import unicode_literals
 
+from __future__ import print_function
 TEST_FILE = 'text-emphasis-ruby-{:03}{}.html'
 TEST_TEMPLATE = '''<!DOCTYPE html>
 <meta charset="utf-8">
@@ -52,7 +53,7 @@ def write_file(filename, content):
     with open(filename, 'wb') as f:
         f.write(content.encode('UTF-8'))
 
-print("# START tests from {}".format(__file__))
+print(("# START tests from {}".format(__file__)))
 idx = 0
 for pos, ref_wm, ruby_pos, subtests in TEST_CASES:
     idx += 1
@@ -65,5 +66,5 @@ for pos, ref_wm, ruby_pos, subtests in TEST_CASES:
         test_content = TEST_TEMPLATE.format(
             wm=wm, pos=pos, index=idx, ruby_pos=ruby_pos, posval=posval)
         write_file(test_file, test_content)
-        print("== {} {}".format(test_file, ref_file))
-print("# END tests from {}".format(__file__))
+        print(("== {} {}".format(test_file, ref_file)))
+print(("# END tests from {}".format(__file__)))
diff --git a/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-style-property-tests.py b/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-style-property-tests.py
index eb14e83bc5..9ecc609659 100644
--- a/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-style-property-tests.py
+++ b/layout/reftests/w3c-css/submitted/text-decor-3/support/generate-text-emphasis-style-property-tests.py
@@ -10,6 +10,7 @@ tests it generated in the format of Mozilla reftest.list to the stdout.
 
 from __future__ import unicode_literals
 
+from __future__ import print_function
 TEST_FILE = 'text-emphasis-style-property-{:03}{}.html'
 TEST_TEMPLATE = '''<!DOCTYPE html>
 <meta charset="utf-8">
@@ -59,7 +60,7 @@ def write_test_file(idx, suffix, style, code, name=None):
                                               char=get_html_entity(code),
                                               code='U+{:04X}'.format(code),
                                               title=name))
-    print("== {} {}".format(filename, REF_FILE.format(idx)))
+    print(("== {} {}".format(filename, REF_FILE.format(idx))))
 
 idx = 10
 def write_files(style, code):
@@ -77,9 +78,9 @@ def write_files(style, code):
     if shape == 'circle':
         write_test_file(idx, next(suffix), fill, code, fill + ', horizontal')
 
-print("# START tests from {}".format(__file__))
+print(("# START tests from {}".format(__file__)))
 for name, code, _ in DATA_SET:
     write_files(('filled', name), code)
 for name, _, code in DATA_SET:
     write_files(('open', name), code)
-print("# END tests from {}".format(__file__))
+print(("# END tests from {}".format(__file__)))
diff --git a/layout/style/GenerateCSSPropsGenerated.py b/layout/style/GenerateCSSPropsGenerated.py
index 5038e9afe7..18ab142fe4 100644
--- a/layout/style/GenerateCSSPropsGenerated.py
+++ b/layout/style/GenerateCSSPropsGenerated.py
@@ -3,6 +3,7 @@
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
 import sys
+import functools
 import string
 import argparse
 import subprocess
@@ -26,7 +27,7 @@ def get_properties(preprocessorHeader):
         property_order = {"longhand": 0, "logical": 0, "shorthand": 1, "alias": 2}
         return property_order[x["proptype"]] - property_order[y["proptype"]]
 
-    properties = sorted(properties, cmp=property_compare)
+    properties = sorted(properties, key=functools.cmp_to_key(property_compare))
 
     for i, p in enumerate(properties):
         p["index"] = i
@@ -62,22 +63,22 @@ def generate_assertions(properties):
             return "eCSSProperty_%s" % p["id"]
     msg = ('static_assert(%s == %d, "GenerateCSSPropsGenerated.py did not list '
            'properties in nsCSSPropertyID order");')
-    return "\n".join(map(lambda p: msg % (enum(p), p["index"]), properties))
+    return "\n".join([msg % (enum(p), p["index"]) for p in properties])
 
 def generate_idl_name_positions(properties):
     # Skip aliases.
-    ps = filter(lambda p: p["proptype"] is not "alias", properties)
+    ps = [p for p in properties if p["proptype"] is not "alias"]
 
     # Sort alphabetically by IDL name.
-    ps = sorted(ps, key=lambda p: p["idlname"])
+    ps = sorted(ps, key=lambda p: (p["idlname"] is None, p["idlname"] or ''))
 
     # Annotate entries with the sorted position.
     ps = [(p, position) for position, p in enumerate(ps)]
 
     # Sort back to nsCSSPropertyID order.
-    ps = sorted(ps, key=lambda (p, position): p["index"])
+    ps = sorted(ps, key=lambda p_position1: p_position1[0]["index"])
 
-    return ",\n".join(map(lambda (p, position): "  %d" % position, ps))
+    return ",\n".join(["  %d" % p_position[1] for p_position in ps])
 
 def generate(output, cppTemplate, preprocessorHeader):
     cppFile = open(cppTemplate, "r")
diff --git a/layout/tools/reftest/mach_commands.py b/layout/tools/reftest/mach_commands.py
index a85181f9a6..871c265e8f 100644
--- a/layout/tools/reftest/mach_commands.py
+++ b/layout/tools/reftest/mach_commands.py
@@ -4,6 +4,7 @@
 
 from __future__ import absolute_import, unicode_literals
 
+from __future__ import print_function
 import os
 import re
 import sys
@@ -149,7 +150,7 @@ class ReftestRunner(MozbuildObject):
         import runreftestmulet
 
         if self.substs.get('ENABLE_MARIONETTE') != '1':
-            print(MARIONETTE_DISABLED % self.mozconfig['path'])
+            print((MARIONETTE_DISABLED % self.mozconfig['path']))
             return 1
 
         if not args.profile:
@@ -161,7 +162,7 @@ class ReftestRunner(MozbuildObject):
 
         if os.path.isfile(os.path.join(args.profile, 'extensions',
                                        'httpd@gaiamobile.org')):
-            print(GAIA_PROFILE_IS_DEBUG % args.profile)
+            print((GAIA_PROFILE_IS_DEBUG % args.profile))
             return 1
 
         args.app = self.get_binary_path()
diff --git a/layout/tools/reftest/mach_test_package_commands.py b/layout/tools/reftest/mach_test_package_commands.py
index 197800cf27..b35eee8110 100644
--- a/layout/tools/reftest/mach_test_package_commands.py
+++ b/layout/tools/reftest/mach_test_package_commands.py
@@ -27,7 +27,7 @@ def run_reftest(context, **kwargs):
 
     test_root = os.path.join(context.package_root, 'reftest', 'tests')
     normalize = partial(context.normalize_test_path, test_root)
-    args.tests = map(normalize, args.tests)
+    args.tests = list(map(normalize, args.tests))
 
     return run_reftest_desktop(context, args)
 
diff --git a/layout/tools/reftest/reftestcommandline.py b/layout/tools/reftest/reftestcommandline.py
index 40bd8a5ee1..5de242df5d 100644
--- a/layout/tools/reftest/reftestcommandline.py
+++ b/layout/tools/reftest/reftestcommandline.py
@@ -2,7 +2,7 @@ import argparse
 import os
 import sys
 from collections import OrderedDict
-from urlparse import urlparse
+from urllib.parse import urlparse
 
 import mozlog
 
@@ -254,7 +254,7 @@ class ReftestArgumentsParser(argparse.ArgumentParser):
                 return
 
         for test_path in options.tests:
-            for manifest_file, suite in manifests.iteritems():
+            for manifest_file, suite in manifests.items():
                 if os.path.exists(os.path.join(test_path, manifest_file)):
                     options.suite = suite
                     return
diff --git a/layout/tools/reftest/remotereftest.py b/layout/tools/reftest/remotereftest.py
index f871c75861..170237d1f3 100644
--- a/layout/tools/reftest/remotereftest.py
+++ b/layout/tools/reftest/remotereftest.py
@@ -2,12 +2,13 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import sys
 import os
 import time
 import tempfile
 import traceback
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 
 import mozdevice
 import mozinfo
@@ -30,7 +31,7 @@ class RemoteReftestResolver(ReftestResolver):
         elif os.path.exists(os.path.abspath(path)):
             rv = os.path.abspath(path)
         else:
-            print >> sys.stderr, "Could not find manifest %s" % script_abs_path
+            print("Could not find manifest %s" % script_abs_path, file=sys.stderr)
             sys.exit(1)
         return os.path.normpath(rv)
 
@@ -88,7 +89,7 @@ class ReftestServer:
         self._process = self.automation.Process([xpcshell] + args, env = env)
         pid = self._process.pid
         if pid < 0:
-            print "TEST-UNEXPECTED-FAIL | remotereftests.py | Error starting server."
+            print("TEST-UNEXPECTED-FAIL | remotereftests.py | Error starting server.")
             return 2
         self.automation.log.info("INFO | remotereftests.py | Server pid: %d", pid)
 
@@ -108,14 +109,14 @@ class ReftestServer:
             time.sleep(1)
             i += 1
         else:
-            print "TEST-UNEXPECTED-FAIL | remotereftests.py | Timed out while waiting for server startup."
+            print("TEST-UNEXPECTED-FAIL | remotereftests.py | Timed out while waiting for server startup.")
             self.stop()
             return 1
 
     def stop(self):
         if hasattr(self, '_process'):
             try:
-                c = urllib2.urlopen(self.shutdownURL)
+                c = six.moves.urllib.request.urlopen(self.shutdownURL)
                 c.read()
                 c.close()
 
@@ -186,7 +187,7 @@ class RemoteReftest(RefTest):
         paths = [options.xrePath, localAutomation.DIST_BIN, self.automation._product, os.path.join('..', self.automation._product)]
         options.xrePath = self.findPath(paths)
         if options.xrePath == None:
-            print "ERROR: unable to find xulrunner path for %s, please specify with --xre-path" % (os.name)
+            print("ERROR: unable to find xulrunner path for %s, please specify with --xre-path" % (os.name))
             return 1
         paths.append("bin")
         paths.append(os.path.join("..", "bin"))
@@ -199,7 +200,7 @@ class RemoteReftest(RefTest):
             paths.insert(0, options.utilityPath)
         options.utilityPath = self.findPath(paths, xpcshell)
         if options.utilityPath == None:
-            print "ERROR: unable to find utility path for %s, please specify with --utility-path" % (os.name)
+            print("ERROR: unable to find utility path for %s, please specify with --utility-path" % (os.name))
             return 1
 
         options.serverProfilePath = tempfile.mkdtemp()
@@ -244,7 +245,7 @@ class RemoteReftest(RefTest):
             self._devicemanager.pushDir(profileDir, options.remoteProfile)
             self._devicemanager.chmodDir(options.remoteProfile)
         except mozdevice.DMError:
-            print "Automation Error: Failed to copy profiledir to device"
+            print("Automation Error: Failed to copy profiledir to device")
             raise
 
         return profile
@@ -256,26 +257,26 @@ class RemoteReftest(RefTest):
             self._devicemanager.pushDir(profileDir, options.remoteProfile)
             self._devicemanager.chmodDir(options.remoteProfile)
         except mozdevice.DMError:
-            print "Automation Error: Failed to copy extra files to device"
+            print("Automation Error: Failed to copy extra files to device")
             raise
 
     def printDeviceInfo(self, printLogcat=False):
         try:
             if printLogcat:
                 logcat = self._devicemanager.getLogcat(filterOutRegexps=fennecLogcatFilters)
-                print ''.join(logcat)
-            print "Device info:"
+                print(''.join(logcat))
+            print("Device info:")
             devinfo = self._devicemanager.getInfo()
             for category in devinfo:
                 if type(devinfo[category]) is list:
-                    print "  %s:" % category
+                    print("  %s:" % category)
                     for item in devinfo[category]:
-                        print "     %s" % item
+                        print("     %s" % item)
                 else:
-                    print "  %s: %s" % (category, devinfo[category])
-            print "Test root: %s" % self._devicemanager.deviceRoot
+                    print("  %s: %s" % (category, devinfo[category]))
+            print("Test root: %s" % self._devicemanager.deviceRoot)
         except mozdevice.DMError:
-            print "WARNING: Error getting device information"
+            print("WARNING: Error getting device information")
 
     def environment(self, **kwargs):
         return self.automation.environment(**kwargs)
@@ -308,8 +309,8 @@ class RemoteReftest(RefTest):
                 self._devicemanager.fileExists(self.remoteLogFile):
             self._devicemanager.getFile(self.remoteLogFile, self.localLogName)
         else:
-            print "WARNING: Unable to retrieve log file (%s) from remote " \
-                "device" % self.remoteLogFile
+            print("WARNING: Unable to retrieve log file (%s) from remote " \
+                "device" % self.remoteLogFile)
         self._devicemanager.removeDir(self.remoteProfile)
         self._devicemanager.removeDir(self.remoteTestRoot)
         RefTest.cleanup(self, profileDir)
@@ -318,12 +319,12 @@ class RemoteReftest(RefTest):
                 os.remove(self.pidFile)
                 os.remove(self.pidFile + ".xpcshell.pid")
             except:
-                print "Warning: cleaning up pidfile '%s' was unsuccessful from the test harness" % self.pidFile
+                print("Warning: cleaning up pidfile '%s' was unsuccessful from the test harness" % self.pidFile)
 
 
 def run_test_harness(parser, options):
     if options.dm_trans == 'sut' and options.deviceIP == None:
-        print "Error: If --dm_trans = sut, you must provide a device IP to connect to via the --deviceIP option"
+        print("Error: If --dm_trans = sut, you must provide a device IP to connect to via the --deviceIP option")
         return 1
 
     dm_args = {
@@ -343,7 +344,7 @@ def run_test_harness(parser, options):
         dm = dm_cls(**dm_args)
     except mozdevice.DMError:
         traceback.print_exc()
-        print "Automation Error: exception while initializing devicemanager.  Most likely the device is not in a testable state."
+        print("Automation Error: exception while initializing devicemanager.  Most likely the device is not in a testable state.")
         return 1
 
     automation = RemoteAutomation(None)
@@ -359,7 +360,7 @@ def run_test_harness(parser, options):
     expected = options.app.split('/')[-1]
     installed = dm.shellCheckOutput(['pm', 'list', 'packages', expected])
     if expected not in installed:
-        print "%s is not installed on this device" % expected
+        print("%s is not installed on this device" % expected)
         return 1
 
     automation.setAppName(options.app)
@@ -369,7 +370,7 @@ def run_test_harness(parser, options):
     parser.validate(options, reftest)
 
     if mozinfo.info['debug']:
-        print "changing timeout for remote debug reftests from %s to 600 seconds" % options.timeout
+        print("changing timeout for remote debug reftests from %s to 600 seconds" % options.timeout)
         options.timeout = 600
 
     # Hack in a symbolic link for jsreftest
@@ -394,7 +395,7 @@ def run_test_harness(parser, options):
         dm.recordLogcat()
         retVal = reftest.runTests(options.tests, options)
     except:
-        print "Automation Error: Exception caught while running tests"
+        print("Automation Error: Exception caught while running tests")
         traceback.print_exc()
         retVal = 1
 
diff --git a/layout/tools/reftest/runreftest.py b/layout/tools/reftest/runreftest.py
index 7061b16ca5..7ea465d48e 100644
--- a/layout/tools/reftest/runreftest.py
+++ b/layout/tools/reftest/runreftest.py
@@ -6,6 +6,7 @@
 Runs the reftest test harness.
 """
 
+from __future__ import print_function
 import collections
 import json
 import multiprocessing
@@ -37,7 +38,7 @@ from mozscreenshot import printstatus, dump_screen
 try:
     from marionette_driver.addons import Addons
     from marionette_harness import Marionette
-except ImportError, e:
+except ImportError as e:
     # Defer ImportError until attempt to use Marionette
     def reraise(*args, **kwargs):
         raise(e)
@@ -85,12 +86,12 @@ class ReftestThread(threading.Thread):
 
     def run(self):
         with printLock:
-            print "Starting thread with", self.cmdargs
+            print("Starting thread with", self.cmdargs)
             sys.stdout.flush()
         process = subprocess.Popen(self.cmdargs, stdout=subprocess.PIPE)
         for chunk in self.chunkForMergedOutput(process.stdout):
             with printLock:
-                print chunk,
+                print(chunk, end=' ')
                 sys.stdout.flush()
         self.retcode = process.wait()
 
@@ -194,7 +195,7 @@ class ReftestResolver(object):
                     manifests[manifest] = set()
                 manifests[manifest].add(filter_str)
 
-        for key in manifests.iterkeys():
+        for key in manifests.keys():
             if None in manifests[key]:
                 manifests[key] = None
             else:
@@ -303,7 +304,7 @@ class RefTest(object):
         for v in options.extraPrefs:
             thispref = v.split('=')
             if len(thispref) < 2:
-                print "Error: syntax error in --setpref=" + v
+                print("Error: syntax error in --setpref=" + v)
                 sys.exit(1)
             prefs[thispref[0]] = thispref[1].strip()
 
@@ -362,7 +363,7 @@ class RefTest(object):
         for v in options.environment:
             ix = v.find("=")
             if ix <= 0:
-                print "Error: syntax error in --setenv=" + v
+                print("Error: syntax error in --setenv=" + v)
                 return None
             browserEnv[v[:ix]] = v[ix + 1:]
 
@@ -498,11 +499,11 @@ class RefTest(object):
                     threadMatches.group('total') if threadMatches else 0)
                 summaryObj['total'] += amount
 
-        print 'REFTEST INFO | Result summary:'
+        print('REFTEST INFO | Result summary:')
         for (summaryObj, (text, categories)) in zip(summaryObjects, summaryLines):
             details = ', '.join(["%d %s" % (summaryObj[attribute], description) for (
                 attribute, description) in categories])
-            print 'REFTEST INFO | ' + text + ': ' + str(summaryObj['total']) + ' (' + details + ')'
+            print('REFTEST INFO | ' + text + ': ' + str(summaryObj['total']) + ' (' + details + ')')
 
         return int(any(t.retcode != 0 for t in threads))
 
diff --git a/layout/tools/reftest/runreftestb2g.py b/layout/tools/reftest/runreftestb2g.py
index 6a6346ece0..5dcba6d420 100644
--- a/layout/tools/reftest/runreftestb2g.py
+++ b/layout/tools/reftest/runreftestb2g.py
@@ -2,7 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-import ConfigParser
+from __future__ import print_function
+import six.moves.configparser
 import os
 import sys
 import tempfile
@@ -25,7 +26,7 @@ from marionette_harness import Marionette
 from mozdevice import DeviceManagerADB, DMError
 
 
-class ProfileConfigParser(ConfigParser.RawConfigParser):
+class ProfileConfigParser(six.moves.configparser.RawConfigParser):
     """Subclass of RawConfigParser that outputs .ini files in the exact
        format expected for profiles.ini, which is slightly different
        than the default format.
@@ -36,7 +37,7 @@ class ProfileConfigParser(ConfigParser.RawConfigParser):
 
     def write(self, fp):
         if self._defaults:
-            fp.write("[%s]\n" % ConfigParser.DEFAULTSECT)
+            fp.write("[%s]\n" % six.moves.configparser.DEFAULTSECT)
             for (key, value) in self._defaults.items():
                 fp.write("%s=%s\n" % (key, str(value).replace('\n', '\n\t')))
             fp.write("\n")
@@ -84,7 +85,7 @@ class B2GRemoteReftest(RefTest):
             try:
                 self._devicemanager.getFile(self.remoteLogFile, self.localLogName)
             except:
-                print "ERROR: We were not able to retrieve the info from %s" % self.remoteLogFile
+                print("ERROR: We were not able to retrieve the info from %s" % self.remoteLogFile)
                 sys.exit(5)
 
         # Delete any bundled extensions
@@ -121,7 +122,7 @@ class B2GRemoteReftest(RefTest):
                 os.remove(self.pidFile)
                 os.remove(self.pidFile + ".xpcshell.pid")
             except:
-                print "Warning: cleaning up pidfile '%s' was unsuccessful from the test harness" % self.pidFile
+                print("Warning: cleaning up pidfile '%s' was unsuccessful from the test harness" % self.pidFile)
 
     def findPath(self, paths, filename = None):
         for path in paths:
@@ -158,7 +159,7 @@ class B2GRemoteReftest(RefTest):
                  os.path.join('..', self.automation._product)]
         options.xrePath = self.findPath(paths)
         if options.xrePath == None:
-            print "ERROR: unable to find xulrunner path for %s, please specify with --xre-path" % (os.name)
+            print("ERROR: unable to find xulrunner path for %s, please specify with --xre-path" % (os.name))
             sys.exit(1)
         paths.append("bin")
         paths.append(os.path.join("..", "bin"))
@@ -169,7 +170,7 @@ class B2GRemoteReftest(RefTest):
 
         options.utilityPath = self.findPath(paths, xpcshell)
         if options.utilityPath == None:
-            print "ERROR: unable to find utility path for %s, please specify with --utility-path" % (os.name)
+            print("ERROR: unable to find utility path for %s, please specify with --utility-path" % (os.name))
             sys.exit(1)
 
         xpcshell = os.path.join(options.utilityPath, xpcshell)
@@ -269,7 +270,7 @@ class B2GRemoteReftest(RefTest):
         try:
             self._devicemanager.pushDir(profileDir, self.remoteProfile)
         except DMError:
-            print "Automation Error: Unable to copy profile to device."
+            print("Automation Error: Unable to copy profile to device.")
             raise
 
         # Copy the extensions to the B2G bundles dir.
@@ -282,7 +283,7 @@ class B2GRemoteReftest(RefTest):
         try:
             self._devicemanager.pushDir(extensionDir, self.bundlesDir)
         except DMError:
-            print "Automation Error: Unable to copy extensions to device."
+            print("Automation Error: Unable to copy extensions to device.")
             raise
 
         self.updateProfilesIni(self.remoteProfile)
@@ -296,7 +297,7 @@ class B2GRemoteReftest(RefTest):
         try:
             self._devicemanager.pushDir(profileDir, options.remoteProfile)
         except DMError:
-            print "Automation Error: Failed to copy extra files to device"
+            print("Automation Error: Failed to copy extra files to device")
             raise
 
     def environment(self, **kwargs):
@@ -375,7 +376,7 @@ def run_test_harness(parser, options):
         width = int(parts[0].split(':')[1])
         height = int(parts[1].split(':')[1])
         if (width < 1366 or height < 1050):
-            print "ERROR: Invalid screen resolution %sx%s, please adjust to 1366x1050 or higher" % (width, height)
+            print("ERROR: Invalid screen resolution %sx%s, please adjust to 1366x1050 or higher" % (width, height))
             return 1
 
     auto.setProduct("b2g")
@@ -406,7 +407,7 @@ def run_test_harness(parser, options):
 
         retVal = reftest.runTests(options.tests, options)
     except:
-        print "Automation Error: Exception caught while running tests"
+        print("Automation Error: Exception caught while running tests")
         traceback.print_exc()
         reftest.stopWebServer(options)
         try:
diff --git a/mach b/mach
index 1759179a33..93efcbee5f 100755
--- a/mach
+++ b/mach
@@ -22,12 +22,13 @@ def ancestors(path):
             break
 
 def load_mach(dir_path, mach_path):
-    import imp
-    with open(mach_path, 'r') as fh:
-        imp.load_module('mach_bootstrap', fh, mach_path,
-                        ('.py', 'r', imp.PY_SOURCE))
-    import mach_bootstrap
-    return mach_bootstrap.bootstrap(dir_path)
+    import importlib.util
+    spec = importlib.util.spec_from_file_location('mach_bootstrap', mach_path)
+    module = importlib.util.module_from_spec(spec)
+    spec.loader.exec_module(module)
+    import sys
+    sys.modules['mach_bootstrap'] = module
+    return module.bootstrap(dir_path)
 
 
 def check_and_get_mach(dir_path):
@@ -59,7 +60,7 @@ def get_mach():
                 # its default locations.
                 #
                 # Note: subprocess requires native strings in os.environ on Windows
-                os.environ[b'MOZCONFIG'] = str(info['mozconfig'])
+                os.environ['MOZCONFIG'] = str(info['mozconfig'])
 
             if 'topsrcdir' in info:
                 # Continue searching for mach_bootstrap in the source directory.
